Unit AF10R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AF10R(M :Integer; K :Integer; var A :Array of Real;
                var U :Array of Real; var T :Array of Real);

implementation

procedure AF10R(M :Integer; K :Integer; var A :Array of Real;
                var U :Array of Real; var T :Array of Real);
var
I,J,L,L1,K1 :Integer;
C,S,ALPHA,RO :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11;
begin
K1 := K-1;
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
_1:
    U[(I-1)+(J-1)*M] := 0.0;
   end;
 end;
for I:=1 to M do
 begin
_2:
  U[(I-1)+(I-1)*M] := 1.0;
 end;
for L:=1 to K do
 begin
  S := 0.0;
  L1 := L+1;
  for I:=L to M do
   begin
    C := 0.0;
    for J:=1 to M do
     begin
_3:
      C := C+U[(I-1)+(J-1)*M]*A[(J-1)+(L-1)*M];
     end;
    T[I-1] := C;
    S := S+C*C;
_4:
   end;
  ALPHA := Sign(Sqrt(S),T[L-1]);
  RO := Sqrt(2.0*ALPHA*(ALPHA+T[L-1]));
  T[L-1] := (ALPHA+T[L-1])/RO;
  for J:=L1 to M do
   begin
_5:
    T[J-1] := T[J-1]/RO;
   end;
  for L1:=1 to M do
   begin
    S := 0.0;
    for I:=L to M do
     begin
_6:
      S := S+T[I-1]*U[(I-1)+(L1-1)*M];
     end;
    S := S+S;
    for J:=L to M do
     begin
_7:
      U[(J-1)+(L1-1)*M] := U[(J-1)+(L1-1)*M]-T[J-1]*S;
     end;
   end;
 end;
L1 := 1;
for I:=1 to K do
 begin
  for J:=I to K do
   begin
    S := 0.0;
    for L:=1 to M do
     begin
_8:
      S := S+U[(I-1)+(L-1)*M]*A[(L-1)+(J-1)*M];
     end;
    T[L1-1] := S;
_9:
    L1 := L1+1;
   end;
 end;
for I:=1 to K1 do
 begin
  for J:=1 to M do
   begin
_10:
    A[(J-1)+(I-1)*M] := U[(I-1)+(J-1)*M];
   end;
 end;
for J:=1 to M do
 begin
_11:
  A[(J-1)+(K-1)*M] := U[(K-1)+(J-1)*M]*S;
 end;
end;

end.
